package com.base.scanqrclear.ui.text

import android.content.ActivityNotFoundException
import android.content.Intent
import android.net.Uri
import android.widget.Toast
import androidx.activity.addCallback
import androidx.core.view.updatePadding
import androidx.lifecycle.ViewModelProvider
import com.base.scanqrclear.R
import com.base.scanqrclear.ads.AdsMgr
import com.base.scanqrclear.ads.AdsShowCallBack
import com.base.scanqrclear.base.BaseActivity
import com.base.scanqrclear.bean.FunctionUIBean
import com.base.scanqrclear.bean.FunctionUIBean.Companion.KEY_TEXT
import com.base.scanqrclear.bean.TextUIBean
import com.base.scanqrclear.bean.config.AdConfigBean
import com.base.scanqrclear.databinding.ActivityTextCodeBinding
import com.base.scanqrclear.ui.exportpdf.ExportPdfActivity
import com.base.scanqrclear.ui.vm.QrViewModel
import com.base.scanqrclear.ui.widget.InputNameDialog.showInputNameDialog
import com.base.scanqrclear.utils.BarUtils
import com.base.scanqrclear.utils.BitmapUtils.saveBitmapToFile
import com.base.scanqrclear.utils.ClipboardUtils.copyText
import com.base.scanqrclear.utils.IntentUtils.intentShareText
import com.base.scanqrclear.utils.LogEx
import com.base.scanqrclear.utils.QRCodeUtils.generateQRCode
import com.base.scanqrclear.utils.SpJsonUtils
import com.base.scanqrclear.utils.ToastUtils.toast
import com.google.gson.Gson
import java.io.File


class TextCodeActivity : BaseActivity<ActivityTextCodeBinding>(ActivityTextCodeBinding::inflate) {

    private var textUIBean = TextUIBean()
    private var tempImagePath: String = ""
    private var qrString = ""
    private val viewModel by lazy(LazyThreadSafetyMode.NONE) {
        ViewModelProvider(this)[QrViewModel::class.java]
    }

    override fun onResumeOneShoot() {
        super.onResumeOneShoot()
        val flag = changeLanguage()
        if (flag) return

        AdsMgr.showBanner(binding.flBanner, false)
    }

    override fun initView() {
        super.initView()
        binding.clTop.updatePadding(top = BarUtils.getStatusBarHeight())
        AdsMgr.showNative(binding.flAd, R.layout.layout_admob_item)

        val data = intent.extras?.getString("data")
        data?.let {
            textUIBean = Gson().fromJson(data, TextUIBean::class.java)
            binding.tvContent.text = textUIBean.content
            qrString = textUIBean.content
        }
        Thread {
            val bitmap = generateQRCode(qrString, 735, 735, 5)
            runOnUiThread {
                binding.ivQr.setImageBitmap(bitmap)
                val file = File(cacheDir, System.currentTimeMillis().toString() + ".jpg")
                bitmap?.let {
                    val flag = saveBitmapToFile(it, file.absolutePath)
                    LogEx.logDebug(TAG, "flag=$flag tempImage=${file.absolutePath}")
                    if (flag) {
                        tempImagePath = file.absolutePath
                    }
                }
                if (textUIBean.needCreate) {
                    textUIBean.needCreate = false
                    SpJsonUtils.addJsonBean<TextUIBean>(FunctionUIBean.KEY_TEXT, textUIBean)
                }
            }
        }.start()
    }

    override fun initListener() {
        super.initListener()
        onBackPressedDispatcher.addCallback {
            if (AdConfigBean.adsConfigBean.functionBackShowAd) {
                AdsMgr.showInsert(this@TextCodeActivity, false, object : AdsShowCallBack() {
                    override fun close(where: Int) {
                        finishToMainTop()
                    }

                    override fun failed(where: Int) {
                        finishToMainTop()
                    }

                    override fun googleFailed(where: Int) {
                        finishToMainTop()
                    }
                })
            } else {
                finishToMainTop()
            }
        }
        binding.flBack.setOnClickListener {
            onBackPressedDispatcher.onBackPressed()
        }
        binding.llShare.setOnClickListener {
            val intent = intentShareText(textUIBean.content)
            runCatching {
                startActivity(intent)
            }
        }
        binding.llPdf.setOnClickListener {
            startActivity(Intent(this, ExportPdfActivity::class.java).apply {
                putExtra("qrType", KEY_TEXT)
                putExtra("qrString", qrString)
            })
        }
        binding.llDownload.setOnClickListener {
            if (AdConfigBean.adsConfigBean.functionUseShowAd) {
                AdsMgr.showInsert(this, true, object : AdsShowCallBack() {
                    override fun close(where: Int) {
                        useDownload()
                    }

                    override fun failed(where: Int) {
                        useDownload()
                    }

                    override fun googleFailed(where: Int) {
                        useDownload()
                    }
                })
            } else {
                useDownload()
            }
        }
        binding.llCopy.setOnClickListener {
            copyText(TAG, textUIBean.content)
            toast("Copied to clipboard", true)
        }
        binding.flSearch.setOnClickListener {
            if (AdConfigBean.adsConfigBean.functionUseShowAd) {
                AdsMgr.showInsert(this, true, object : AdsShowCallBack() {
                    override fun close(where: Int) {
                        useSearch()
                    }

                    override fun failed(where: Int) {
                        useSearch()
                    }

                    override fun googleFailed(where: Int) {
                        useSearch()
                    }
                })
            } else {
                useSearch()
            }
        }
    }

    fun useDownload() {
        kotlin.runCatching {
            val newName = File(tempImagePath).name
            showInputNameDialog(newName) { name ->
                viewModel.copyFileToDownloads(this, name, tempImagePath)
            }
        }
    }

    fun useSearch() {
        val intent = Intent(Intent.ACTION_VIEW)
        intent.setData(Uri.parse("https://www.google.com/search?q=${textUIBean.content}"))

        try {
            startActivity(intent)
        } catch (e: ActivityNotFoundException) {
            toast("")
            Toast.makeText(this, "No application was found to handle the search request", Toast.LENGTH_SHORT).show()
        }
    }


}